/***************************************************************************
 *									   *
 *				  WK1(...)				   *
 *									   *
 *			       UDF for Clipper				   *
 *									   *
 * Dateibersetzung vom CLIPPER (DBF) in das LOTUS 1-2-3 Rel 2 (WK1)	   *
 * Format.								   *
 *									   *
 * Aufruf von Clipper:	  WK1(SOURCE,DEST,MEM,LIC,HEADLINE,EXCEL)	   *
 *			  SOURCE   : Quelldatei (DBF)			   *
 *			  DEST	   : Zieldatei (WK1, falls leer Name	   *
 *						wie Quelldatei	    )	   *
 *			  MEM	   : Lnge von Memofeldern		   *
 *				     (0=Memofelder berspringen)	   *
 *			  LIC	   : .T. LICS-Zeichensatz verwenden	   *
 *				     .F. IBM-Zeichensatz verwenden	   *
 *			  HEADLINE : .T. Feldnamen als			   *
 *					 Spaltenberschriften		   *
 *				     .F. Feldnamen nicht bernehmen	   *
 *			  EXCEL    : .F. Zielprogramm 1-2-3		   *
 *				     .T. Zielprogramm Excel		   *
 *									   *
 * Die Einstellung von SET DELETED wird beim Konvertieren bercksichtigt ! *
 *									   *
 * Besonderes:		  Ein Teil der C-Bibliotheksfunktionen wurde	   *
 *			  nachgebildet. Achtung: Ein Teil dieser	   *
 *			  Funktionen verhlt sich u. U. etwas anders	   *
 *			  als die "echten" Bibliotheksroutinen. 	   *
 *									   *
 * MS C 5.1				       Speicher-Modell: LARGE	   *
 *									   *
 ***************************************************************************/

#define MY_LIB

#ifndef MY_LIB
	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>
	#include <malloc.h>
	#include <math.h>
	#include <io.h>
#else
	#include <string.h>
	#include "nandef.h"
	#include "extend.h"
	#include "sybexlib.h"
	double	floor(double);
#endif

#define MAX_REC 8191
#define CLIP			     /* nicht verndern! */
#define CLIPSO87		     /* fr CLIPPER 5.0 entfernen */

static int translate(void);	     /* Prototypes */
static void write_lab(void);
static void write_val(void);
static void col_row(void);
static char *strrtrim(char *);
static char *trans_lics(char *);
static char *memo_tran(char *);
static char *c_upper(char *);

#ifdef CLIPSO87
  extern unsigned int _deleted_on;	 /* Clipper-Public Variable fr SET DELETED-Schalter */
#endif

FILE *WK_1,*dbf,*dbt;
int lic,headline,excel,i,j,deleted;
unsigned int mem=240,l_int;
char in_file[81],out_file[81];
unsigned char *r;
double l_doub;
char l_label[256];

char start[6]={0,0,2,0,6,4};
char gross[8]={6,0,8,0,0,0,0,0};
char width[4]={8,0,3,0};
char ende[4]={1,0,0,0};
char r_begin[4]={0x47,0,0x19,0};
unsigned char true[12]={0,0,0,0,0,0,0xF0,0x3F,2,0,0x34,3};
unsigned char false[12]={0,0,0,0,0,0,0,0,2,0,0x33,3};

unsigned char lics[128]=
	    {199, 252, 233, 226, 228, 224, 229, 231, 234,
	     235, 232, 239, 238, 236, 196, 197, 201, 230,
	     198, 244, 246, 242, 251, 249, 253, 214, 220,
	     162, 163, 165, 166, 160, 225, 237, 243, 250,
	     241, 209, 170, 186, 191, 254, 254, 189, 188,
	     161, 171, 187, 254, 254, 254, 254, 254, 254,
	     254, 254, 254, 254, 254, 254, 254, 254, 254,
	     254, 254, 254, 254, 254, 254, 254, 254, 254,
	     254, 254, 254, 254, 254, 254, 254, 254, 254,
	     254, 254, 254, 254, 254, 254, 254, 254, 254,
	     254, 254, 254, 254, 254, 254, 254, 223, 254,
	     173, 254, 254, 181, 254, 254, 254, 254, 254,
	     254, 248, 254, 254, 254, 177, 174, 190, 254,
	     254, 175, 254, 176, 154, 254, 254, 254, 178,
	     140, 254};

CLIPPER wk1()
{
  int  i;

  if(_parinfo(1)!=CHARACTER)		 /* Check Parameters */
  {
    _retni(-1);
    return;
  }
  strcpy(in_file,_parc(1));
  if(!my_strchr(in_file,'.'))
    strcat(in_file,".dbf");
  strcpy(out_file,_parinfo(2)!=CHARACTER||my_strlen(_parc(2))==0?in_file:_parc(2));
  if(!my_strchr(out_file,'.'))
    strcat(out_file,".");
  strcpy(my_strchr(out_file,'.'),".WK1");
  for(i=3;i<7;i++)
  {
    if(_parinfo(i)!=UNDEF&&_parinfo(i)!=(i==3?NUMERIC:LOGICAL))
    {
      _retni(-1);
      return;
    }
    switch(i)
    {
      case 3:
	if(_parinfo(3)!=UNDEF)
	{
	  mem=_parni(3);
	  mem=mem>240?240:mem;
	}
	break;
      case 4:
	if(_parinfo(4)==UNDEF)
	  lic=TRUE;
	else
	  lic=_parl(4);
	break;
      case 5:
	if(_parinfo(5)==UNDEF)
	  headline=TRUE;
	else
	  headline=_parl(5);
	break;
      case 6:
	if(_parinfo(5)==UNDEF)
	  excel=FALSE;
	else
	  excel=_parl(5);
	break;
    }
  }
  #ifdef CLIPSO87
    deleted=_deleted_on;
  #endif
  WK_1=dbf=dbt=NULL;
  _retni(translate());
  if(WK_1)
    my_fclose(WK_1);
  if(dbf)
    my_fclose(dbf);
  if(dbt)
    my_fclose(dbt);
}

static int translate()
{
   #ifndef CLIPSO87
     unsigned int workvar;
   #endif
   unsigned char sign,*p,*q,*s;
   unsigned long recno;
   int fieldno,header,w_rec,memo,fc=0,y,m,d,rec_size,k=0,size;
   unsigned int ol_s,ur_z;
   char memofile[81],r_name[16],ys[5],ms[3],ds[3];
   long block;

   if((dbf=my_fopen(in_file,"rb"))==NULL) /* ffne .DBF-Datei, read, binay */
     return(-5);

   my_fread(&sign,1,1,dbf);		  /* Erstes Byte des Header lesen */

   if(sign&3!=3)			  /* Gltig ? */
     return(-3);

   memo=sign&0x80;			   /* Memodatei ? */
   my_fseek(dbf,(long)4,SEEK_SET);
   my_fread(&recno,4,1,dbf);		   /* Anzahl der Records holen */
   my_fread(&header,2,1,dbf);
   fieldno=header;
   fieldno/=32;
   size=--fieldno*17;			   /* Anzahl der Felder */
   if(!(p=_exmgrab(size)))
     return(-2);
   my_fread(&rec_size,1,2,dbf); 	   /* Datensatzgre */

   my_fseek(dbf,(long)15,SEEK_SET);
   my_fread(&sign,1,1,dbf);		   /* Verschlsselt ? */
   if(sign)
   {
     _exmback(p,size);
     return(-4);
   }

  if((WK_1=my_fopen(out_file,"wb"))==NULL)  /* Wk1-Datei ffnen */
  {
    _exmback(p,size);
    return(-5);
  }
  my_fwrite(start,1,6,WK_1);		    /* Start des Worksheets */
  fieldno--;
  w_rec=(int)recno>MAX_REC ? MAX_REC : (int)recno;
  my_fwrite(gross,1,8,WK_1);		    /* Tabellengre angeben */
  my_fwrite(&fieldno,1,2,WK_1);
  my_fwrite(&w_rec,1,2,WK_1);
  my_fseek(dbf,(long)32,SEEK_SET);

  if(memo&&mem) 			   /* Falls Memodatei	   */
  {
    strcpy(memofile,in_file);
    strcpy(my_strchr(memofile,'.'),".DBT");
    if(my_access(memofile,0)==0) 	   /* Memodatei vorhanden */
    {
      if((dbt=my_fopen(memofile,"rb"))==NULL)
      {
	_exmback(p,size);
	return(-5);
      }
      my_fseek(dbt,(long)8,SEEK_SET);
      my_memset(r_name,0,16);
      my_fread(r_name,1,8,dbt);
      strcpy(my_strchr(r_name,'\0'),".DBF");
      if(my_strcmp(c_upper(r_name),c_upper(in_file))!=0)
	memo=512;
      else
      {
	my_fseek(dbt,(long)21,SEEK_SET);
	my_fread(&memo,1,1,dbt);
	memo= (memo==0 ? 2 : memo);
	memo*=256;			    /* Blocksize */
      }
    }
    else
      memo=0;
  }
  else
    memo=0;

  q=p;
  while(my_fgetc(dbf)!=13) 		   /* Lese Feldliste aus Header */
  {
    my_fseek(dbf,(long)-1,SEEK_CUR);
    r=q;
    my_fread(q,1,11,dbf);			   /* Feldname */
    q+=12;
    my_fread(q,1,1,dbf);			   /* Feldtyp */
    my_fseek(dbf,(long)(k+1)*32+16,SEEK_SET);
    ++q;
    #ifdef CLIPSO87  /* Der rger mit 64k langen Zeichenfeldern */
      my_fread(q++,1,1,dbf);			   /* Feldlnge */
    #else
      if(*(q-1)=='C')				   /* Zeichenfeld */
	my_fread(q++,1,2,dbf);
      else
	my_fread(q++,1,1,dbf);
    #endif
    ++q;
    *q=*(q-2);

    switch (*(q-3))
    {
      case 'M':
       *q=mem>72?72:mem+1;
	 break;
      case 'N':case 'F':
	*q=*q+1;
	break;
      case 'L':
       *q=excel?8:2;
       break;
      case 'D':
	*q=10;
	break;
      case 'C':
	#ifdef CLIPSO87
	  *q=*q>(unsigned char)72 ? (unsigned char)72:*q;
	#else
	  workvar=*(unsigned int*)(q-2);
	  *q=(byte)(workvar>72?72:workvar);
	#endif
    }
    if(excel)
     *q++;
    ++q;
    my_fread(q,1,1,dbf);			   /* Dezimalstellen */
    ++q;
    if(!(*(q-5)=='M'&&!memo))
    {
      my_fwrite(width,1,4,WK_1);		    /* Spaltenweite in 1-2-3 Tabelle */
      my_fwrite(&fc,1,2,WK_1);
      r+=15;
      my_fwrite(r,1,1,WK_1);
      ++fc;
    }
    ++k;
    my_fseek(dbf,(k+1)*(long)32,SEEK_SET);
  }

  my_fwrite("d\0 ",1,3,WK_1); 	    	/* Range-Tabelle erffnen */
  for(i=1;i<34;i++)
    my_fwrite("\0",1,1,WK_1);
  my_fwrite(r_begin,1,4,WK_1);
  my_memset(r_name,0,16);
  strcpy(r_name,"DATA");
  my_fwrite(r_name,1,16,WK_1);
  my_fwrite("\0\0\0\0",1,4,WK_1);
  my_fwrite(&fieldno,1,2,WK_1);
  my_fwrite(&w_rec,1,2,WK_1);
  my_fwrite("\x01",1,1,WK_1);

  ol_s=0;
  for(i=0;i<=w_rec;i+=100)	    /* Definiere Unterranges alle 100 Zeilen */
  {
    ur_z=i+99;
    my_memset(r_name,0,16);
    strcpy(r_name,"DATA");
    my_itoa(i/100,my_strchr(r_name,'\0'),10);
    my_fwrite(r_begin,1,4,WK_1);
    my_fwrite(r_name,1,16,WK_1);
    my_fwrite(&ol_s,1,2,WK_1);
    my_fwrite(&i,1,2,WK_1);
    my_fwrite(&fieldno,1,2,WK_1);
    my_fwrite(&ur_z,1,2,WK_1);
    my_fwrite("\x01",1,1,WK_1);
  }

  ur_z=w_rec;
  for(j=0,k=0,q=p;k<=fieldno;j++,k++,q=p+17*k)	 /* Spalten als Ranges definieren */
  {
    if(!(*(q+12)=='M'&&!memo))
    {
      my_memset(r_name,0,16);
      strcpy(r_name,q);
      my_fwrite(r_begin,1,4,WK_1);
      my_fwrite(r_name,1,16,WK_1);
      my_fwrite(&j,1,2,WK_1);
      my_fwrite(&ol_s,1,2,WK_1);
      my_fwrite(&j,1,2,WK_1);
      my_fwrite(&ur_z,1,2,WK_1);
      my_fwrite("\x01",1,1,WK_1);
     }
     else
       j--;
  }

  if(headline)				     /* Spaltenberschrifen */
    for(i=0,k=0,q=p;k<=fieldno;k++,i++)
    {
      if(!(*(q+12)=='M'&&!memo))
      {
	my_fwrite("\x0f\0",1,2,WK_1);
	j=my_strlen(q)+7;
	my_fwrite(&j,1,2,WK_1);
	my_fwrite("\xff",1,1,WK_1);
	my_fwrite(&i,1,2,WK_1);
	if(lic)
	  trans_lics(q);		      /* LICS Konversion */
	r=q+12;
	sign=(unsigned char)(my_strchr("NFL",*r) ? 34 : 39);
	my_fwrite("\0\0",1,2,WK_1);
	my_fwrite(&sign,1,1,WK_1);
	my_fwrite(q,1,j-7,WK_1);
	my_fwrite("\0",1,1,WK_1);
      }
      else
      {
	i--;
      }
      q+=17;
    }

  *(ys+4)=*(ms+2)=*(ds+2)=0;
  my_fseek(dbf,(long)header,SEEK_SET);
  for(i=1;i<=w_rec;i++) 		/* Datenstze schreiben */
  {
    q=p;
    my_fread(&sign,1,1,dbf);
    if(my_feof(dbf))			/* Dateiende erreicht */
      break;
    if(sign==0x2a&&deleted) 		/* Deleted ?		*/
    {
      i--;
      recno--;
      if(recno<MAX_REC)
	w_rec--;
      my_fseek(dbf,(long)rec_size-1,SEEK_CUR);
      continue;
    }

    for(j=0,k=0;k<=fieldno;j++,k++,q=p+17*k)   /* Feldliste abarbeiten */
    {
      my_memset(l_label,0,255);
      y=0;
      q+=12;
      r=q+1;
      switch (*q)			/* Feldtyp bestimmen	*/
      {
	case 'C':
	  #ifdef CLIPSO87
   	    my_fread(l_label,1,*r,dbf);
	  #else
	    workvar=*(unsigned int*)r;
	    my_fread(l_label,1,workvar>240?240:workvar,dbf);
	    if(workvar>240)
	    {
	      *(l_label+240)='\0';
	      my_fseek(dbf,(long)workvar-240L,SEEK_CUR);
	    }
	    memo_tran(l_label); 	/* Harte und weiche Zeilenumbr.*/
	  #endif
	  l_int=my_strlen(strrtrim(l_label))+7;
	  if(l_int>247)
	  {
	    *(l_label+240)='\0';
	    l_int=247;
	  }
	  if(l_int>7)
	  {
	    write_lab();
	  }
	  break;
	case 'N': case 'F':
	  my_fread(l_label,1,*r,dbf);
	  if(my_strlen(strrtrim(l_label))>0&&*l_label!='*')
	  {
	    r+=3;
	    ol_s=*r;
	    if(my_strcspn(l_label,"eE")==my_strlen(l_label))
	      *r=(unsigned char)0x80|*r;
	    else
	      *r=0xFF;
	    l_doub=my_atof(l_label);
	    write_val();
	    *r=(char)ol_s;
	  }
	  break;
	case 'D':
	  my_fread(ys,1,4,dbf);
	  my_fread(ms,1,2,dbf);
	  my_fread(ds,1,2,dbf);
	  y=my_atoi(ys);
	  m=my_atoi(ms);
	  d=my_atoi(ds);
	  if(y>1899&&y<2100)
	  {
	    y=m<3 ? y-1 : y;		    /* Datum Sn berechnen */
	    m=m<3 ? m+13 : m+1;
	    l_doub=floor(365.25*y)-floor(y/100)+floor(y/400)
	    +floor(30.6001*m)+d-694023;
	    if((unsigned int)l_doub>61)		   /* 1-2-3 Bug bercksichtigen */
	      ++l_doub;
	    r+=2;
	    *r=0xF2;
	    write_val();
	  }
	  break;
	case 'M':		       /* Memofeld */
	  my_fread(l_label,1,10,dbf);
	  if(memo)
	  {
	    if(!(block=my_atol(l_label)))
	      break;
	    my_fseek(dbt,block*memo,SEEK_SET);
	    my_fread(&ol_s,1,2,dbt);
	    my_memset(l_label,0,11);
	    if(ol_s!=-1)
	    {
	      my_fseek(dbt,block*memo,SEEK_SET);
	      s=l_label;
	      my_fread(s,1,1,dbt);
	      while(*s!=0x1a&&s-l_label<mem)
	      {
		s++;
		my_fread(s,1,1,dbt);
	      }
	      *s='\0';
	      if(my_strlen(l_label)>mem)
		*(l_label+mem)=0;
	    }
	    else								    {
	      my_fread(&ol_s,1,2,dbt);
	      my_fread(&ur_z,1,2,dbt);
	      my_fseek(dbt,block*memo+ol_s,SEEK_SET);
	      ur_z-=ol_s;
	      if(ur_z>mem)
		ur_z=mem;
	      my_fread(l_label,1,ur_z,dbt);
	    }
	    memo_tran(l_label); 	/* Harte und weiche Zeilenumbr.*/
					/* beseitigen		       */
	    l_int=my_strlen(l_label)+7;
	    write_lab();
	  }
	  else
	    j--;
	  break;
	case 'L':
	  my_fread(l_label,1,1,dbf);
	  my_fwrite("\x10\0\x11\0\x80",1,5,WK_1);
	  col_row();
	  if(my_strchr("TtJjWw",*l_label))
	    my_fwrite(true,1,12,WK_1);
	  else
	    my_fwrite(false,1,12,WK_1);
      }
    }
  }
  my_fwrite(ende,1,4,WK_1);
  _exmback(p,size);
  return(1);
}

static char *strrtrim(t)
char *t;
{
  register char *p;
  p=my_strchr(t,'\0');
  --p;
  while(*p==32&&p>=t)
    --p;
  ++p;
  *p='\0';
  return(t);
}

static void write_lab()
{
  my_fwrite("\x0f\0",1,2,WK_1);	   /* Label  */
  my_fwrite(&l_int,1,2,WK_1);	   /* Lnge  */
  my_fwrite("\xff",1,1,WK_1);	   /* Format */
  col_row();
  if(lic)
    trans_lics(l_label);	    /* Aufruf LICS Konversion */
  my_fwrite("'",1,1,WK_1);
  my_fwrite(l_label,1,my_strlen(l_label),WK_1);
  my_fwrite("\0",1,1,WK_1);
}

static void write_val()
{
  if(l_doub<32768L&&l_doub>-32769L&&l_doub==floor(l_doub))
  {
     l_int=(int)l_doub;
     my_fwrite("\x0d\0\x07\0",1,4,WK_1);	/* Integer */
     my_fwrite(r,1,1,WK_1);			/* Format */
     col_row();
     my_fwrite(&l_int,1,2,WK_1);		/* Integer-Wert */
   }
   else
   {
     my_fwrite("\x0e\0\x0d\0",1,4,WK_1);	/* Double IEEE */
     my_fwrite(r,1,1,WK_1);			/* Format */
     col_row();
     my_fwrite(&l_doub,1,8,WK_1);		/* Gleitkommawert */
    }
}

static void col_row()
{
   if(!headline)
     i--;
   my_fwrite(&j,1,2,WK_1);	      /* Spalte */
   my_fwrite(&i,1,2,WK_1);	      /* Zeile	*/
   if(!headline)
     i++;
}

static char *trans_lics(t)
char *t;
{
   register unsigned char *p;
   int len;

   len=(int)t+my_strlen(t);
   for(p=t;(int)p<len;p++)
   {
     if(*p>127)
       *p=*(lics+*p-128);
   }
   return(t);
}

static char *memo_tran(t)
char *t;
{
  char *p,*e;
  e=my_strchr(t,'\0');
  #if defined CLIP
    while(p=my_strchr(t,0x8D))		   /* Clippers MEMOEDIT fgt  ein */
    {
      *p=32;
      my_memmove(p+1,p+2,(int)(e-p));
    }
  #endif
  while(p=my_strchr(t,10))
    my_memmove(p,p+1,(int)(e-p));
  while(p=my_strchr(t,9))
    my_memmove(p,p+1,(int)(e-p));
  while(p=my_strchr(t,13))
    *p=32;
  return(t);
}

static char *c_upper(t)
char *t;
{
   char *i;
   for(i=t;i<t+my_strlen(t);i++)
     *i=(char)my_toupper((int)*i);
   return(t);
}

/* That's all folks ! */